/*
 *  linux/arch/arm/mach-pxa/gumstix.c
 *
 *  Support for the Gumstix computer platform
 *
 *  Author:	Craig Hughes
 *  Created:	December 8 2004
 *  Copyright:	(C) 2004, Craig Hughes
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.
 */

#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/mach-types.h>
#include <asm/mach/arch.h>
#include <asm/arch/udc.h>
#include <asm/arch/pxa-regs.h>
#include <asm/arch/gumstix.h>                                                                                                                                                                         

#include "generic.h"


static int gumstix_udc_is_connected(void)
{
  return 1; /* always connected on Fiona board (hardwired pull up to D+ */
#if 0
  return !! (GPLR(GPIO_GUMSTIX_USB_GPIOn) & GPIO_bit(GPIO_GUMSTIX_USB_GPIOn));
#endif

}

static void gumstix_udc_command(int connect_command)
{
#if 0
	if (connect_command == PXA2XX_UDC_CMD_CONNECT) {
		pxa_gpio_mode(GPIO_GUMSTIX_USB_GPIOx_CON_MD);
		GPSR(GPIO_GUMSTIX_USB_GPIOx) = GPIO_bit(GPIO_GUMSTIX_USB_GPIOx);
	}
	if (connect_command == PXA2XX_UDC_CMD_DISCONNECT) {
		GPCR(GPIO_GUMSTIX_USB_GPIOx)  = GPIO_bit(GPIO_GUMSTIX_USB_GPIOx);
		pxa_gpio_mode(GPIO_GUMSTIX_USB_GPIOx_DIS_MD);
	}
#endif
}

static struct pxa2xx_udc_mach_info gumstix_udc_info __initdata = {
	.udc_is_connected	= gumstix_udc_is_connected,
	.udc_command		= gumstix_udc_command,
};

static void __init gumstix_init(void)
{
	pxa_gpio_mode(GPIO6_MMCCLK_MD);
	pxa_gpio_mode(GPIO8_MMCCS0_MD);
       	pxa_set_udc_info(&gumstix_udc_info); 
}

MACHINE_START(GUMSTIX, "The Gumstix Platform")
	MAINTAINER("Craig Hughes <craig@gumstix.com>")
	BOOT_PARAMS(0xa0000100)
	BOOT_MEM(0xa0000000, 0x40000000, io_p2v(0x40000000))
	.timer          = &pxa_timer,
	MAPIO(pxa_map_io)
	INITIRQ(pxa_init_irq)
	INIT_MACHINE(gumstix_init)
MACHINE_END
