/*
 * Tool for managing arbitrary binary data.
 *
 * Copyright (C)2006-2007 Lab126, Inc.  All rights reserved.
 */

#ifndef _IMAGE_MANAGER_H
#define _IMAGE_MANAGER_H

#include <common.h>

#define FILL_WHITE  true
#define FILL_BLACK  false

#define HAS_HEADER  false
#define NO_HEADER   true

enum image_type
{
    image_picture_logo = 0,
    
    image_picture_service_menu_all,
    
    image_picture_service_menu_update,    
    image_picture_service_menu_recover,
    image_picture_service_menu_exit,
    
    image_picture_update_snag,
    image_picture_recover_snag,
    
#ifdef CONFIG_USE_ALERT_PICTURES
    image_picture_no_battery,
    image_picture_low_battery,
    image_picture_powercycle,
    image_picture_doa,
#endif

    num_images,
    image_unknown
};
typedef enum image_type image_type;

struct picture_info
{
    int     x,
            y;
    bool    fill_white,
            headerless;
    int     xres,
            yres,
            bpp;
};
typedef struct picture_info picture_info;

extern int uncompress_image(image_type which_image, u8 *image_buffer, u32 *buffer_length, void **image_data);
extern int gunzip(u8 *dst, u32 dstlen, u8 *src, u32 *srclen);

#endif // _IMAGE_MANAGER_H
